@if (!displayDeletingConfirmationMessage) {
  <div class="mobile-only">
    @if (!selectedCity) {
      <ng-container
        [ngTemplateOutlet]="chooseLocationMobile">
      </ng-container>
    } @else {
      <ng-container
        [ngTemplateOutlet]="reportLocationMobile">
      </ng-container>
    }

    @if (displayFullFormOnMobile) {
      <ng-container
        [ngTemplateOutlet]="reportFormTemplate">
      </ng-container>
    }
  </div>
  <div class="desktop-only">
    @if (!selectedCity) {
      <ng-container
        [ngTemplateOutlet]="chooseLocationDesktop">
      </ng-container>
    } @else {
      <ng-container
        [ngTemplateOutlet]="reportLocation">
      </ng-container>
    }
    <ng-container [ngTemplateOutlet]="reportFormTemplate"></ng-container>
  </div>
  <ng-template #chooseLocationMobile>
    <h1 class="fr-text--lead fr-mb-0">
      Choisissez l’emplacement du signalement en cliquant sur la carte
    </h1>
  </ng-template>
  <ng-template #chooseLocationDesktop>
    <h1 class="fr-text--lead">Choisissez l'emplacement du signalement</h1>
    <p class="fr-mb-1w">
      Cliquez sur la carte afin de placer le marqueur sur le lieu que vous avez
      identifié comme ayant une difficulté de couverture du réseau mobile.
      Remplissez ensuite le formulaire ci-dessous, puis cliquez sur le bouton
      “Enregistrer”.
    </p>
  </ng-template>
  <ng-template #reportLocationMobile>
    <ng-container [ngTemplateOutlet]="reportLocation"></ng-container>
    @if (!displayFullFormOnMobile) {
      <dsfr-button
        id="validate-location-button"
        (click)="onLocationValidated()"
        label="Valider">
      </dsfr-button>
    } @else {
      <p
        id="location-hint">
        Pour modifier l’emplacement, cliquer sur le marqueur bleu
      </p>
    }
  </ng-template>
  <ng-template #reportLocation>
    <h1 class="fr-text--lead fr-mb-2w">Emplacement du signalement</h1>
    <infra-num-location-details
      [selectedCity]="selectedCity"
      [preferredCoordinates]="preferredCoordinates"
      [features]="[possibleFeatures.CanLocalize]"
      (featureClicked)="onLocalizeClicked()"></infra-num-location-details>
  </ng-template>
  <ng-template #reportFormTemplate>
    @if (selectedCity) {
      <p
        id="form-instruction">
        Remplissez le formulaire ci-dessous, puis cliquez sur le bouton
        “Enregistrer”.
      </p>
    }
    <p class="fr-text--xs mandatory-fields">
      Tous les champs sont obligatoires.
    </p>
    <form
      [formGroup]="reportForm"
      (submit)="onSubmit()">
      <dsfr-checkbox
        [items]="reportLocatedProblemItems"
        formControlName="locatedProblem"
        legend="Où le problème est-il situé ?"
        name="reportLocatedProblem"
        legendId="reportLocatedProblem">
      </dsfr-checkbox>
      <dsfr-checkbox
        [items]="reportWhatYouCantDoItems"
        formControlName="whatYouCantDo"
        legend="Que ne pouvez-vous pas faire ?"
        name="reportWhatYouCantDo"
        legendId="reportWhatYouCantDo">
      </dsfr-checkbox>
      <dsfr-checkbox
        [items]="reportWhichOperatorsItems"
        formControlName="whichOperators"
        legend="Quels sont les opérateurs concernés ?"
        name="reportWhichOperators"
        legendId="reportWhichOperators">
      </dsfr-checkbox>
      <dsfr-input
        type="textarea"
        formControlName="description"
        label="Décrivez la situation"
        hint="Par exemple, les lieux où le réseau vous pose problème, le nombre de locaux concernés, les enjeux de sécurité, des événements particuliers ..."
        name="reportDescription"
        id="reportDescription">
      </dsfr-input>
      <hr>
      <fieldset formGroupName="cityHallContact">
        <legend class="fr-text--lead">
          Informations de contact
        </legend>
        <p class="fr-text--xs optional-fields">
          Ces champs sont optionnels
        </p>
        <p>
          Nous utilisons les coordonnées de votre mairie disponibles sur
          <dsfr-link
            label="l’annuaire du service public"
            [link]="environment.servicePublicPhoneBook"
            title="Vers l’annuaire du service public"
            [inline]="true">
          </dsfr-link>.
          Vous pouvez cependant spécifier ici des coordonnées de préférence sur lesquelles votre équipe
          projet locale pourra vous contacter.
        </p>
        <p class="fr-text--xs optional-fields">
          Indiquez le nom du contact et un numéro de téléphone ou une adresse électronique.
        </p>
        <dsfr-input
          label="Prénom Nom"
          icon="user-line"
          formControlName="fullName"
          name="cityHallContactName"
          id="cityHallContactName">
        </dsfr-input>
        <dsfr-input
          label="Téléphone"
          icon="phone-line"
          formControlName="phone"
          name="cityHallContactPhone"
          id="cityHallContactPhone">
        </dsfr-input>
        <dsfr-input
          label="Adresse électronique"
          formControlName="email"
          icon="mail-line"
          name="cityHallContactEmail"
          id="cityHallContactEmail">
        </dsfr-input>
      </fieldset>
      <div class="buttons">
        <div class="ordered-buttons">
          <dsfr-button
            (buttonClicked)="cancelReportCreationOrEdition()"
            label="Annuler"
            [type]="buttonType.SECONDARY">
          </dsfr-button>
          <dsfr-button
            label="Enregistrer"
            [disabled]="!reportForm.valid || !selectedCity?.marker"
            [htmlType]="htmlType.SUBMIT">
          </dsfr-button>
        </div>
        @if ((data?.report) && ((user?._id === data?.report.author?._id) || (user?.roles?.includes(roles.ANCT)))) {
          <hr>
          <dsfr-button
            (buttonClicked)="displayDeletingConfirmationMessage = true"
            class="btn-delete"
            label="Supprimer le signalement"
            [type]="buttonType.TERTIARY"
            [size]="elementSize.SMALL"
            icon="fr-icon-delete-line"
            [htmlType]="htmlType.BUTTON">
          </dsfr-button>
        }
      </div>
    </form>
  </ng-template>
} @else {
  <h1 class="fr-h4">Supprimer le signalement</h1>
  <p>
    Voulez-vous supprimer définitivement ce signalement ?
  </p>
  <p>
    Cette action est irréversible.
  </p>
  <div class="buttons">
    <div class="ordered-buttons">
      <dsfr-button
        (buttonClicked)="displayDeletingConfirmationMessage = false"
        label="Annuler"
        [type]="buttonType.SECONDARY">
      </dsfr-button>
      <dsfr-button
        class="btn-delete"
        label="Supprimer"
        (buttonClicked)="deleteReport()"
        [htmlType]="htmlType.SUBMIT">
      </dsfr-button>
    </div>
  </div>
}